require "spec_helper"
require "rampart/session"

describe Rampart::Session do
  it "can store session" do
    env = {
      "rampart.session.key" => :user_id,
      "rack.session" => {}
    }
    session = Rampart::Session.new(env)
    user_id = 123
    session.store(user_id)
    env["rack.session"].must_equal(:user_id => 123)
  end

  it "can fetch session" do
    env = {
      "rampart.session.key" => :user_id,
      "rack.session" => {:user_id => 123}
    }
    session = Rampart::Session.new(env)
    session.fetch.must_equal(123)
  end

  it "can delete session" do
    env = {
      "rampart.session.key" => :user_id,
      "rack.session" => {:user_id => 123}
    }
    session = Rampart::Session.new(env)
    session.delete
    session.fetch.must_be_nil
  end
end