require 'minitest/autorun'
require "rampart/strategy"
require "rampart/strategy_manager"

def define_strategy_manager(env={})
  Rampart::StrategyManager.new(env)
end

def define_passing_strategy
  klass = Class.new do
    include Rampart::Strategy
    def valid?(req)
      true
    end

    def authenticate!(req)
      pass
    end
  end
  klass.new
end

def define_failing_strategy
  klass = Class.new do
    include Rampart::Strategy
    def valid?(req)
      true
    end

    def authenticate!(req)
      fail!
    end
  end
  klass.new
end

def define_redirecting_strategy
  klass = Class.new do
    include Rampart::Strategy
    def valid?(req)
      true
    end

    def authenticate!(req)
      redirect!("http://www.kodio.io")
    end
  end
  klass.new
end

def define_succeeding_strategy(user=Object.new)
  klass = Class.new do
    include Rampart::Strategy

    def initialize(user)
      @user = user
    end

    def valid?(req)
      true
    end

    def authenticate!(req)
      success!(@user)
    end
  end
  klass.new(user)
end

def define_invalid_strategy
  klass = Class.new do
    include Rampart::Strategy
    def valid?(req)
      false
    end

    def authenticate!(req)
    end
  end
  klass.new
end